Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCKMeansClusterGenerator.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCKMeansClusterGenerator.cpp	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCKMeansClusterGenerator.cpp	(revision 751)
@@ -74,97 +74,106 @@
 void KMeansClusterGenerator::recomputeBillboard(BBC::BillboardPtr billboard)
 {
-	Ogre::Matrix3 nmii = Ogre::Matrix3::ZERO;
-	Ogre::Matrix3 nmiiSum = Ogre::Matrix3::ZERO;
-	Ogre::Matrix3 miiSum = Ogre::Matrix3::ZERO;
-	Ogre::Matrix3 mii = Ogre::Matrix3::ZERO;	
-	Ogre::Matrix3 mijSum = Ogre::Matrix3::ZERO;
-	Ogre::Matrix3 mij = Ogre::Matrix3::ZERO; 
-	Ogre::Vector3 lastY = Ogre::Vector3::ZERO;
-	Ogre::Vector3 piSum = Ogre::Vector3::ZERO;
-	Ogre::Vector3 normSum = Ogre::Vector3::ZERO;
-
 	BillboardKMeansClusterData *billboardClusterData = (BillboardKMeansClusterData*)billboard->getBillboardClusterData().get();			
 	BBC::EntityClusterPtr entityCluster = billboardClusterData->getEntityCluster();
 
-	for (unsigned int iLeaf = 0; iLeaf < entityCluster->getNumEntitiesClusterData(); iLeaf++)
-	{
-		Leaf* leaf = (Leaf*)entityCluster->getEntityClusterData(iLeaf)->getEntity().get();
-		Ogre::Vector3 pi = leaf->getPosition();	
-		Ogre::Vector3 norm2 = leaf->getLeafNormal();	
-		piSum = piSum + pi * (1.0 / (float)entityCluster->getNumEntitiesClusterData());
+	if (entityCluster->getNumEntitiesClusterData() > 1)
+	{
+		Ogre::Matrix3 nmii = Ogre::Matrix3::ZERO;
+		Ogre::Matrix3 nmiiSum = Ogre::Matrix3::ZERO;
+		Ogre::Matrix3 miiSum = Ogre::Matrix3::ZERO;
+		Ogre::Matrix3 mii = Ogre::Matrix3::ZERO;	
+		Ogre::Matrix3 mijSum = Ogre::Matrix3::ZERO;
+		Ogre::Matrix3 mij = Ogre::Matrix3::ZERO; 
+		Ogre::Vector3 lastY = Ogre::Vector3::ZERO;
+		Ogre::Vector3 piSum = Ogre::Vector3::ZERO;
+		Ogre::Vector3 normSum = Ogre::Vector3::ZERO;
+
+		for (unsigned int iLeaf = 0; iLeaf < entityCluster->getNumEntitiesClusterData(); iLeaf++)
+		{
+			Leaf* leaf = (Leaf*)entityCluster->getEntityClusterData(iLeaf)->getEntity().get();
+			Ogre::Vector3 pi = leaf->getPosition();	
+			Ogre::Vector3 norm2 = leaf->getLeafNormal();	
+			piSum = piSum + pi * (1.0 / (float)entityCluster->getNumEntitiesClusterData());
+				
+			mii[0][0] = pi.x * pi.x;
+			mii[0][1] = pi.x * pi.y;
+			mii[0][2] = pi.x * pi.z;
+			mii[1][0] = pi.y * pi.x;
+			mii[1][1] = pi.y * pi.y;
+			mii[1][2] = pi.y * pi.z;
+			mii[2][0] = pi.z * pi.x;
+			mii[2][1] = pi.z * pi.y;
+			mii[2][2] = pi.z * pi.z;	
+			nmii[0][0] = norm2.x * norm2.x;
+			nmii[0][1] = norm2.x * norm2.y;
+			nmii[0][2] = norm2.x * norm2.z;
+			nmii[1][0] = norm2.y * norm2.x;
+			nmii[1][1] = norm2.y * norm2.y;
+			nmii[1][2] = norm2.y * norm2.z;
+			nmii[2][0] = norm2.z * norm2.x;
+			nmii[2][1] = norm2.z * norm2.y;
+			nmii[2][2] = norm2.z * norm2.z;	
 			
-		mii[0][0] = pi.x * pi.x;
-		mii[0][1] = pi.x * pi.y;
-		mii[0][2] = pi.x * pi.z;
-		mii[1][0] = pi.y * pi.x;
-		mii[1][1] = pi.y * pi.y;
-		mii[1][2] = pi.y * pi.z;
-		mii[2][0] = pi.z * pi.x;
-		mii[2][1] = pi.z * pi.y;
-		mii[2][2] = pi.z * pi.z;	
-		nmii[0][0] = norm2.x * norm2.x;
-		nmii[0][1] = norm2.x * norm2.y;
-		nmii[0][2] = norm2.x * norm2.z;
-		nmii[1][0] = norm2.y * norm2.x;
-		nmii[1][1] = norm2.y * norm2.y;
-		nmii[1][2] = norm2.y * norm2.z;
-		nmii[2][0] = norm2.z * norm2.x;
-		nmii[2][1] = norm2.z * norm2.y;
-		nmii[2][2] = norm2.z * norm2.z;	
+			nmiiSum = nmiiSum + ( nmii * (1.0 / (float)entityCluster->getNumEntitiesClusterData()));
+
+			miiSum = miiSum + ( mii * (1.0 / (float)entityCluster->getNumEntitiesClusterData()));
+
+			// Generate the initial value for the iterative method as the average...
+			Ogre::Vector3 norm = leaf->getLeafNormal();
+			lastY = lastY + norm;
+
+			// Generate the sum normal of all the leaves associated to the plane...
+			normSum = normSum + norm;
+		}
 		
-		nmiiSum = nmiiSum + ( nmii * (1.0 / (float)entityCluster->getNumEntitiesClusterData()));
-
-		miiSum = miiSum + ( mii * (1.0 / (float)entityCluster->getNumEntitiesClusterData()));
-
-		// Generate the initial value for the iterative method as the average...
-		Ogre::Vector3 norm = leaf->getLeafNormal();
-		lastY = lastY + norm;
-
-		// Generate the sum normal of all the leaves associated to the plane...
-		normSum = normSum + norm;
-	}
-	
-	mijSum[0][0] = piSum.x * piSum.x;
-	mijSum[0][1] = piSum.x * piSum.y;
-	mijSum[0][2] = piSum.x * piSum.z;
-	mijSum[1][0] = piSum.y * piSum.x;
-	mijSum[1][1] = piSum.y * piSum.y;
-	mijSum[1][2] = piSum.y * piSum.z;
-	mijSum[2][0] = piSum.z * piSum.x;
-	mijSum[2][1] = piSum.z * piSum.y;
-	mijSum[2][2] = piSum.z * piSum.z;	
-
-	Ogre::Matrix3 mA = miiSum - mijSum;
-	mA = mA - (mAlpha * nmiiSum);
-	mA = mA.Inverse();
-
-	lastY.normalise();
-	normSum.normalise();
-
-	// Apply the iterative approach
-	Ogre::Vector3 currY;
-	currY = mA * lastY;
-	currY.normalise();
-
-	for(unsigned int icount = 0; icount < 100; icount++)
-	{
-		lastY = currY;
+		mijSum[0][0] = piSum.x * piSum.x;
+		mijSum[0][1] = piSum.x * piSum.y;
+		mijSum[0][2] = piSum.x * piSum.z;
+		mijSum[1][0] = piSum.y * piSum.x;
+		mijSum[1][1] = piSum.y * piSum.y;
+		mijSum[1][2] = piSum.y * piSum.z;
+		mijSum[2][0] = piSum.z * piSum.x;
+		mijSum[2][1] = piSum.z * piSum.y;
+		mijSum[2][2] = piSum.z * piSum.z;	
+
+		Ogre::Matrix3 mA = miiSum - mijSum;
+		mA = mA - (mAlpha * nmiiSum);
+		mA = mA.Inverse();
+
+		lastY.normalise();
+		normSum.normalise();
+
+		// Apply the iterative approach
+		Ogre::Vector3 currY;
 		currY = mA * lastY;
 		currY.normalise();
-	}
-
-	// Generate the d parameter...
-	float sumD = 0;
-	for (unsigned int iLeaf = 0; iLeaf < entityCluster->getNumEntitiesClusterData(); iLeaf++)
-	{
-		Leaf* leaf = (Leaf*)entityCluster->getEntityClusterData(iLeaf)->getEntity().get();
-		Ogre::Vector3 pi = leaf->getPosition();	
-		sumD = sumD + pi.dotProduct(currY);
-	}
-
-	sumD = - sumD / (float)entityCluster->getNumEntitiesClusterData();
-
-	billboardClusterData->setNormal(currY);
-	billboardClusterData->setD(sumD);
+
+		for(unsigned int icount = 0; icount < 100; icount++)
+		{
+			lastY = currY;
+			currY = mA * lastY;
+			currY.normalise();
+		}
+
+		// Generate the d parameter...
+		float sumD = 0;
+		for (unsigned int iLeaf = 0; iLeaf < entityCluster->getNumEntitiesClusterData(); iLeaf++)
+		{
+			Leaf* leaf = (Leaf*)entityCluster->getEntityClusterData(iLeaf)->getEntity().get();
+			Ogre::Vector3 pi = leaf->getPosition();	
+			sumD = sumD + pi.dotProduct(currY);
+		}
+
+		sumD = - sumD / (float)entityCluster->getNumEntitiesClusterData();
+
+		billboardClusterData->setNormal(currY);
+		billboardClusterData->setD(sumD);
+	}
+	else if (entityCluster->getNumEntitiesClusterData() == 1)
+	{
+		Leaf* leaf = (Leaf*)entityCluster->getEntityClusterData(0)->getEntity().get();
+		billboardClusterData->setNormal(leaf->getLeafNormal());
+		billboardClusterData->setD(leaf->getLeafD());
+	}
 }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IBRBillboardCloudTreeApplication.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IBRBillboardCloudTreeApplication.cpp	(revision 747)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/IBRBillboardCloudTreeApplication.cpp	(revision 751)
@@ -59,5 +59,6 @@
 		//mLBBCManager->loadSampleConfigFile(mOpts.cfg);
 		mLBBCManager->initialize();
-		mLBBCManager->loadBillboardCloudMergedXML();
+		//mLBBCManager->loadBillboardCloudMergedXML();
+		mLBBCManager->loadBillboardCloudGroupedXML();
 		this->go();	
 		for (unsigned int iFrameListenerMode = 0; iFrameListenerMode < mFrameListener->getNumFrameListenerModes(); iFrameListenerMode++)
@@ -147,40 +148,4 @@
 
 	{
-		LBBC::BillboardCloudTextureViewMode *anotherFrameListenerMode;
-		anotherFrameListenerMode = new LBBC::BillboardCloudTextureViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
-		anotherFrameListenerMode->chooseSceneManager();
-		anotherFrameListenerMode->createCamera();
-		anotherFrameListenerMode->createViewports();
-		anotherFrameListenerMode->setTextureAtlasSize(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasSize());
-		anotherFrameListenerMode->setTextureSize(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureSize());
-		anotherFrameListenerMode->setTextureAtlasBitRange(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasBitRange());
-		anotherFrameListenerMode->setTextureAtlasName(mSampleConfigFile->getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasName());
-		anotherFrameListenerMode->setTextureAtlasFolder(mSampleConfigFile->getBillboardCloudFolder());
-		anotherFrameListenerMode->setEntityName(mSampleConfigFile->getEntityClustersMergedMeshName());
-		anotherFrameListenerMode->createScene();
-		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
-	}
-
-	{
-		LBBC::ClusterViewMode *anotherFrameListenerMode;
-		anotherFrameListenerMode = new LBBC::ClusterViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
-		anotherFrameListenerMode->chooseSceneManager();
-		anotherFrameListenerMode->createCamera();
-		anotherFrameListenerMode->createViewports();
-		anotherFrameListenerMode->createScene();
-		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
-	}
-
-	{
-		LBBC::BillboardViewMode *anotherFrameListenerMode;
-		anotherFrameListenerMode = new LBBC::BillboardViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
-		anotherFrameListenerMode->chooseSceneManager();
-		anotherFrameListenerMode->createCamera();
-		anotherFrameListenerMode->createViewports();
-		anotherFrameListenerMode->createScene();
-		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
-	}
-
-	{
 		LBBC::EntityTextureAtlasViewMode *textureAtlasFrameListenerMode;
 		textureAtlasFrameListenerMode = new LBBC::EntityTextureAtlasViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
@@ -199,4 +164,46 @@
 	}
 
+	{
+		LBBC::BillboardCloudTextureViewMode *anotherFrameListenerMode;
+		anotherFrameListenerMode = new LBBC::BillboardCloudTextureViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
+		anotherFrameListenerMode->chooseSceneManager();
+		anotherFrameListenerMode->createCamera();
+		anotherFrameListenerMode->createViewports();
+		anotherFrameListenerMode->setTextureAtlasSize(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasSize());
+		anotherFrameListenerMode->setTextureSize(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureSize());
+		anotherFrameListenerMode->setTextureAtlasBitRange(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasBitRange());
+		anotherFrameListenerMode->setTextureAtlasName(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasName());
+		anotherFrameListenerMode->setTextureName(mSampleConfigFile->getBillboardCloudDiffuseColorEntityTextureName());
+		anotherFrameListenerMode->setTextureAtlasFolder(mSampleConfigFile->getBillboardCloudFolder());
+		anotherFrameListenerMode->setEntityClustersGroupedName(mSampleConfigFile->getEntityClustersGroupedMeshName());
+		//anotherFrameListenerMode->setBillboardCloudSplittedName(mSampleConfigFile->getBillboardCloudSplittedMeshName());
+		anotherFrameListenerMode->setBillboardCloudSplittedName(mSampleConfigFile->getBillboardCloudIndirectPointMeshName());
+		anotherFrameListenerMode->setBillboardCloudGroupedTextureAtlasDebug(mSampleConfigFile->getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasDebug());
+		anotherFrameListenerMode->createScene();
+		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
+	}
+
+	{
+		LBBC::BillboardViewMode *anotherFrameListenerMode;
+		anotherFrameListenerMode = new LBBC::BillboardViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
+		anotherFrameListenerMode->chooseSceneManager();
+		anotherFrameListenerMode->createCamera();
+		anotherFrameListenerMode->createViewports();
+		//anotherFrameListenerMode->setBillboardCloudMeshName(mSampleConfigFile->getBillboardCloudGroupedMeshName());
+		anotherFrameListenerMode->createScene();
+		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
+	}
+
+	{
+		LBBC::ClusterViewMode *anotherFrameListenerMode;
+		anotherFrameListenerMode = new LBBC::ClusterViewMode(mWindow,mFrameListener->getNumFrameListenerModes());
+		anotherFrameListenerMode->chooseSceneManager();
+		anotherFrameListenerMode->createCamera();
+		anotherFrameListenerMode->createViewports();
+		//anotherFrameListenerMode->setEntityClustersMeshName(mSampleConfigFile->getEntityClustersGroupedMeshName());
+		anotherFrameListenerMode->createScene();
+		mFrameListener->addFrameListenerMode(anotherFrameListenerMode);
+	}
+
 	mFrameListener->removeFrameListenerMode(0);
 	mFrameListener->setEnabledFrameListenerMode(0);
